package org.apache.commons.lang3.time;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.text.FieldPosition;
import java.text.Format;
import java.text.ParseException;
import java.text.ParsePosition;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;
import java.util.TimeZone;
import org.apache.commons.lang3.time.DateParser;
import org.apache.commons.lang3.time.DatePrinter;
import org.apache.commons.lang3.time.FastDateParser;
import org.apache.commons.lang3.time.FastDatePrinter;
import org.apache.commons.lang3.time.FormatCache;

public class FastDateFormat extends Format implements DateParser, DatePrinter {
  private static final long serialVersionUID = 2L;
  
  public static final int FULL = 0;
  
  public static final int LONG = 1;
  
  public static final int MEDIUM = 2;
  
  public static final int SHORT = 3;
  
  private static final FormatCache<org.apache.commons.lang3.time.FastDateFormat> cache = (FormatCache<org.apache.commons.lang3.time.FastDateFormat>)new Object();
  
  private final FastDatePrinter printer;
  
  private final FastDateParser parser;
  
  public static org.apache.commons.lang3.time.FastDateFormat getInstance() {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getInstance();
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getInstance(String pattern) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getInstance(pattern, null, null);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getInstance(String pattern, TimeZone timeZone) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getInstance(pattern, timeZone, null);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getInstance(String pattern, Locale locale) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getInstance(pattern, null, locale);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getInstance(String pattern, TimeZone timeZone, Locale locale) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getInstance(pattern, timeZone, locale);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getDateInstance(int style) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getDateInstance(style, null, null);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getDateInstance(int style, Locale locale) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getDateInstance(style, null, locale);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getDateInstance(int style, TimeZone timeZone) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getDateInstance(style, timeZone, null);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getDateInstance(int style, TimeZone timeZone, Locale locale) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getDateInstance(style, timeZone, locale);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getTimeInstance(int style) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getTimeInstance(style, null, null);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getTimeInstance(int style, Locale locale) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getTimeInstance(style, null, locale);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getTimeInstance(int style, TimeZone timeZone) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getTimeInstance(style, timeZone, null);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getTimeInstance(int style, TimeZone timeZone, Locale locale) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getTimeInstance(style, timeZone, locale);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getDateTimeInstance(int dateStyle, int timeStyle) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getDateTimeInstance(dateStyle, timeStyle, null, null);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getDateTimeInstance(int dateStyle, int timeStyle, Locale locale) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getDateTimeInstance(dateStyle, timeStyle, null, locale);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getDateTimeInstance(int dateStyle, int timeStyle, TimeZone timeZone) {
    return getDateTimeInstance(dateStyle, timeStyle, timeZone, null);
  }
  
  public static org.apache.commons.lang3.time.FastDateFormat getDateTimeInstance(int dateStyle, int timeStyle, TimeZone timeZone, Locale locale) {
    return (org.apache.commons.lang3.time.FastDateFormat)cache.getDateTimeInstance(dateStyle, timeStyle, timeZone, locale);
  }
  
  protected FastDateFormat(String pattern, TimeZone timeZone, Locale locale) {
    this(pattern, timeZone, locale, null);
  }
  
  protected FastDateFormat(String pattern, TimeZone timeZone, Locale locale, Date centuryStart) {
    this.printer = new FastDatePrinter(pattern, timeZone, locale);
    this.parser = new FastDateParser(pattern, timeZone, locale, centuryStart);
  }
  
  public StringBuffer format(Object obj, StringBuffer toAppendTo, FieldPosition pos) {
    return toAppendTo.append(this.printer.format(obj));
  }
  
  public String format(long millis) {
    return this.printer.format(millis);
  }
  
  public String format(Date date) {
    return this.printer.format(date);
  }
  
  public String format(Calendar calendar) {
    return this.printer.format(calendar);
  }
  
  @Deprecated
  public StringBuffer format(long millis, StringBuffer buf) {
    return this.printer.format(millis, buf);
  }
  
  @Deprecated
  public StringBuffer format(Date date, StringBuffer buf) {
    return this.printer.format(date, buf);
  }
  
  @Deprecated
  public StringBuffer format(Calendar calendar, StringBuffer buf) {
    return this.printer.format(calendar, buf);
  }
  
  public <B extends Appendable> B format(long millis, B buf) {
    return this.printer.format(millis, buf);
  }
  
  public <B extends Appendable> B format(Date date, B buf) {
    return this.printer.format(date, buf);
  }
  
  public <B extends Appendable> B format(Calendar calendar, B buf) {
    return this.printer.format(calendar, buf);
  }
  
  public Date parse(String source) throws ParseException {
    return this.parser.parse(source);
  }
  
  public Date parse(String source, ParsePosition pos) {
    return this.parser.parse(source, pos);
  }
  
  public boolean parse(String source, ParsePosition pos, Calendar calendar) {
    return this.parser.parse(source, pos, calendar);
  }
  
  public Object parseObject(String source, ParsePosition pos) {
    return this.parser.parseObject(source, pos);
  }
  
  public String getPattern() {
    return this.printer.getPattern();
  }
  
  public TimeZone getTimeZone() {
    return this.printer.getTimeZone();
  }
  
  public Locale getLocale() {
    return this.printer.getLocale();
  }
  
  public int getMaxLengthEstimate() {
    return this.printer.getMaxLengthEstimate();
  }
  
  public boolean equals(Object obj) {
    if (!(obj instanceof org.apache.commons.lang3.time.FastDateFormat))
      return false; 
    org.apache.commons.lang3.time.FastDateFormat other = (org.apache.commons.lang3.time.FastDateFormat)obj;
    return this.printer.equals(other.printer);
  }
  
  public int hashCode() {
    return this.printer.hashCode();
  }
  
  public String toString() {
    return "FastDateFormat[" + this.printer.getPattern() + "," + this.printer.getLocale() + "," + this.printer.getTimeZone().getID() + "]";
  }
  
  @Deprecated
  protected StringBuffer applyRules(Calendar calendar, StringBuffer buf) {
    return this.printer.applyRules(calendar, buf);
  }
}
